$debug  
        implicit real*8 (a-h,o-z)
	  Dimension KODE(1025), F(1025)        
        Pi = 4.d0 * datan(1.d0)
        open(2,file='L3DAXI04.in',status='unknown')
        write(*,'('' TEST de L3DAXI01.for jeux de donnes cylindre''/,
     &  '' D, H, Nombre de fa7 et Nh: ''\)')
        read(*,*)D, H, N, Nh
        write (2,'('' Test de L3DAXI04.for N='',i2)')N
        Ni = 8
	  Nsx = 0
        write (2,'(2i6)')Nsx,N,Ni+1,1,N+1
c
c       Maillage  Ds constant
c
        Np =  D/(D+H)*N/2. + .5
        Nc =  N -2*Np
        j = 1

        Do 1 i=0, Np-1
        X = H
        Y = D/2. * Dble(i)/Dble(np)
        F(j) = 0.
	  Kode(j)=-1
        j = j+1
1       write(2,'(2f12.8)')X,Y
c        
        Do 2 i=0, Nc-1
        x = H -H*Dble(i)/Dble(Nc)
        XM = H -H*Dble(i+.5d0)/Dble(Nc)
        Y = D/2.d0 
        F(j) = dsin(Nh*pi*XM/H)
	  Kode(j)=-2
        j = j+1
2       write(2,'(2f12.8)')X,Y
c        
        Do 3 i=0, Np
        x = 0.
        Y = D/2.d0-D/2.d0*Dble(i)/Dble(np) 
        F(j) = 0.
	  Kode(j)=-1
        j=j+1
3       write(2,'(2f10.6)')X,Y
c        
c       contditions aux limites
c
        Do 10 i=1,N
10      write(2,'(i5,f10.6)')Kode(i),F(i)
c
c       Point intrieurs, maillage a DTheta costant
c
        rrr = .5
        Do 4 i=0,Ni
        th = Pi * Dble(i)/Dble(Ni)
        x = H/2. + rrr*H/2.*dcos(th)
        Y = rrr*D/2.*dsin(th)
4       write(2,'(2f12.8)')X,Y
c
c
      write(2,'(//'' Solution analytique, Flux''/)')
c        
c
c       Solution analytique flux sur la partie plane x=H
c
      open(11,file='in1.txt')

      Do 12 i=0, Np-1
      X = H
      Y = D/2. * (Float(i)+.5)/float(np)

	Ri = Y/D*2.d0
      Zpi = X
      n = Nh

	aK = n * Pi / H
	tg = aK*dexp( -aK*(1.-Ri) ) * BESI0 (aK*Ri) / BESI0 (aK)
	Fana = tg * dcos (aK*(zPi))
	s = Y
      write(2,'(f12.8,2X,F12.8)')s,fana    
      write(11,'(f12.8,2X,F12.8)')s,fana    
12    continue        
 
c
c
c       Solution analytique flux en paroi verticale 
c
c
      Do 11 i=0, Nc-1
      x = H -H*(Dble(i)+.5)/Dble(Nc)
      Y = D/2. 
      Zpi = x
      Ri = 1.d0
      n = Nh

      aK = n * Pi / H
      tg = aK * BESI1 (aK) / BESI0 (aK)
      Fana = tg * dsin (aK*(zPi))
	S = D/2.d0 + (H-X)
      write(2,'(f12.8,2X,F12.8)')s,fana    
      write(11,'(f12.8,2X,F12.8)')s,fana
	
11    continue

      Flux = Pi * D* H * BESI1 (aK) / BESI0 (aK)
	write(*,*) 'Flux ', flux

c        
c
c       Solution analytique flux sur la partie plane x=0
c
      Do 13 i= Np-1, 0, -1
      X = 0.
      Y = D/2. * (Dble(i)+.5)/Dble(np)

	Ri = Y/D*2.d0
      Zpi = X
      n = Nh

	aK = n * Pi / H
	tg = aK*dexp( -aK*(1.d0-Ri) ) * BESI0 (aK*Ri) / BESI0 (aK)
	Fana = tg * dcos (aK*(zPi))

	S = D/2.d0 + H + (D/2.d0-Y)
      write(2,'(f12.8,2X,F12.8)')s,-fana    
      write(11,'(f12.8,2X,F12.8)')s,-fana    

13    continue        
c
c     Solution analytique, Points intrieurs
c
      open (12,file='in2')
      write(2,'(//'' Solution analytique, Potentiel''/)')
c
        Do 14 i=0,Ni
        th = Pi * Dble(i)/Dble(Ni)
        x = H/2. + rrr*H/2.*dcos(th)
        Y = rrr*D/2.*dsin(th)

	Ri = Y
	zPi = x
	n = 1
	tg = 1.
	Fana = 0.

30      if (tg.le.1.e-6) goto 31
	aK = n * Pi / H
	tg = 2./aK * dexp(-aK * (1.-Ri) ) * BESI0 (aK*Ri) / BESI0 (aK)
	Fana = Fana + tg * dsin (aK*(zPi))
	n = n + 2
	goto 30
31      continue
       write(12,*)fana
       write(2,'(''R :'',F10.6,'' Z :'',f10.6,'' F :'', F10.6)')X,Y,fana
14    continue
      END
$page
	real*8 function BESI0(x)
      implicit real*8 (a-h,o-z)
c
c       Bessel function of order 0 multiplied by exp(-|x|)
c
	dimension c(7),d(9)
	data d/ .39894 228,     .01328 592,     .00225 319,
     &          -.00157 565,    .00916 281,     -.02057 706,
     &          .02635 537,     -.01647 633,    .00392 377 /
	data c/ 1.      ,       3.5156229,      3.0899424,
     &          1.2067492,      .2659732,       .0360768,       
     &          .0045813 /
c
	t = x / 3.75d0
	ax = abs(x)
c
	if(abs(t).le.1.d0) then
c
	t = t*t
	BESI0 = (((((C(7)*t+C(6))*t+C(5))*t+C(4))*t+C(3))*t+C(2))*t+C(1)
	eax = dexp(ax)
	BESI0 = BESI0 / eax
	else
	t = 1.d0/dabs(t)   
	BESI0 = (((((((D(9)*t+D(8))*t+D(7))*t+D(6))*t+D(5))*t+D(4))*t
     &          +D(3))*t+D(2))*t+D(1)
	BESI0 = BESI0 / dsqrt(ax) 
	endif
	end     
$page
	real*8 function BESI1(x)
      implicit real*8 (a-h,o-z)

c
c       Bessel function of order 1 multiplied by exp(-|x|)
c
	dimension c(7),d(9)
	data d/ .39894 228,     -.03988 024,    -.00362 018,
     &          .00163 801,     -.01031 555,    .02282 967,
     &          -.02895 312,    .01787 654,     -.00420 059/
	data c/ .5,             .87890 594,     .51498 869,
     &          .15084 934,     .02658 733,     .00301 532,
     &          .00032 411/
c
	t = x/3.75d0
	ax = abs(x)
	if(abs(t).le.1.d0) then
c
	t = t*t
	BESI1 = (((((C(7)*t+C(6))*t+C(5))*t+C(4))*t+C(3))*t+C(2))*t+C(1)
	BESI1 = X * BESI1 * dexp(-ax)
	else
	t = 1./dabs(t)   
	BESI1 = (((((((D(9)*t+D(8))*t+D(7))*t+D(6))*t+D(5))*t+D(4))*t
     &          +D(3))*t+D(2))*t+D(1)
	BESI1 = BESI1 / dsqrt(ax)
	endif
	end